import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import React, { useState } from 'react';
import PropTypes from 'prop-types';

var withSwitchValue = function withSwitchValue(BaseComponent) {
  var displayName = BaseComponent.displayName;

  var BaseComponentWithState = function BaseComponentWithState(_ref) {
    var _ref$value = _ref.value,
        valueFromProps = _ref$value === void 0 ? false : _ref$value,
        onChangeFromProps = _ref.onChange,
        props = _objectWithoutProperties(_ref, ["value", "onChange"]);

    var _useState = useState(valueFromProps),
        _useState2 = _slicedToArray(_useState, 2),
        value = _useState2[0],
        setValue = _useState2[1];

    var onChange = function onChange(e) {
      var innerValue = !value;
      setValue(innerValue);
      onChangeFromProps(e, {
        value: innerValue
      });
    };

    return React.createElement(BaseComponent, Object.assign({}, props, {
      value: value,
      onChange: onChange
    }));
  };

  BaseComponentWithState.displayName = "withSwitchValue(" + displayName + ")";
  BaseComponentWithState.defaultProps = {
    onChange: function onChange() {}
  };
  return BaseComponentWithState;
};

export default withSwitchValue;